-- Research
data:extend(
{

  {
    type = "technology",
    name = "factory-backbone",
    icon = "__factory_backbone__/graphics/icon/backbone-icon-128.png",
	icon_size = 128,
    effects =
    {
      {
        type = "unlock-recipe",
        recipe = "factory-backbone"
      }
    },
    prerequisites = {"electric-energy-distribution-2", "optics", "logistic-robotics", "construction-robotics", "advanced-electronics-2"},
    unit =
    {
      count = 500,
      ingredients =
      {
        {"alien-science-pack", 1},
        {"science-pack-1", 1},
        {"science-pack-2", 1},
        {"science-pack-3", 1}
      },
      time = 30
    },
    order = "c-e-d"
  },

}
)
-- Factory Backbone Recipe
data:extend(
{
  {
    type = "recipe",
    name = "factory-backbone",
    enabled = "false",
    energy_required = 30,
    ingredients =
    {
      {"processing-unit", 20},
      {"steel-plate", 15},
	  {"small-lamp", 5},
	  {"battery", 5}
    },
    result = "factory-backbone",

    icon = "__factory_backbone__/graphics/icon/backbone-icon.png",

  },
}
)
-- Items
data:extend(
{

  {
    type = "item",
    name = "factory-backbone",
    icon = "__factory_backbone__/graphics/icon/backbone-icon.png",
    flags = {"goes-to-quickbar"},
    subgroup = "energy-pipe-distribution",
    order = "a[energy]-e[factory-backbone]",
    place_result = "factory-backbone",
    stack_size = 50
  },
  {
		type = "item",
		name = "backbone-light",
		icon = "__factory_backbone__/graphics/icon/backbone-icon.png",
		flags = {"hidden"},
		subgroup = "energy",
		order = "a[energy]-e[factory-backbone]",
		place_result = "backbone-light",
		stack_size = 50
   },
	{
		type = "item",
		name = "backbone-logistics",
		icon = "__factory_backbone__/graphics/icon/backbone-icon.png",
		flags = {"hidden"},
		subgroup = "energy",
		order = "a[energy]-e[factory-backbone]",
		place_result = "backbone-logistics",
		stack_size = 50
	}
	
 }
)
-- Entities
data:extend(
{
  {
    type = "electric-pole",
    name = "factory-backbone",
    icon = "__factory_backbone__/graphics/icon/backbone-icon.png",
    flags = {"placeable-neutral", "player-creation"},
    minable = {hardness = 0.2, mining_time = 1.5, result = "factory-backbone"},
    max_health = 350,
    corpse = "small-remnants",
    collision_box = {{-0.05, -0.05}, {0.05, 0.05}},
    selection_box = {{-0.5, -0.5}, {0.5, 0.5}},
    drawing_box = {{-0.5, -2.6}, {0.5, 0.5}},
    maximum_wire_distance = 36.5,
    supply_area_distance = 18.5,

    vehicle_impact_sound =  { filename = "__base__/sound/car-metal-impact.ogg", volume = 1.0 },
    pictures =
    {
      filename = "__factory_backbone__/graphics/entity/backbone.png",
      priority = "extra-high",
      width = 256,
      height = 256,
	  axially_symmetrical = false,
	  direction_count = 1,
	  scale = 0.45,
      shift = {0, -1.25},
    },
		connection_points =
		{
			{
				shadow =
				{
					copper = {0.6, -0.6},
					green = {0.6, -0.6},
					red = {0.6, -0.6}
				},
				wire =
				{
					copper = {0.6, -2.25},
					green = {0.6,-2.25},
					red = {0.6,-2.25}
				}
			},
		},

		radius_visualisation_picture =
		{
			filename = "__base__/graphics/entity/small-electric-pole/electric-pole-radius-visualization.png",
			width = 16,
			height = 16
		}

	},
	
  {
    type = "lamp",
    name = "backbone-light",
    icon = "__factory_backbone__/graphics/icon/backbone-icon.png",
    flags = {"placeable-neutral","placeable-off-grid", "not-blueprintable"},
    minable = {hardness = 0.2, mining_time = 5},
    max_health = 350,
    corpse = "small-remnants",
    collision_box = {{0, 0}, {0, 0}},
    selection_box = {{-0.25, (-0.25)-2.75 }, {0.25, (0.25)-2.75}},
    energy_source =
    {
      type = "electric",
      usage_priority = "secondary-input"
    },
    energy_usage_per_tick = "50KW",
    light = {intensity = 0.9, size = 100},
    light_when_colored = {intensity = 1, size = 6},
    glow_size = 6,
    glow_color_intensity = 0.135,
    picture_off =
    {
      filename = "__factory_backbone__/graphics/entity/blank.png",
      priority = "medium",
      width = 1,
      height = 1,
	  axially_symmetrical = false,
	  direction_count = 1,
--      shift = {1, -0.75},
    },
    picture_on =
    {
      filename = "__factory_backbone__/graphics/entity/backbonelighton.png",
      priority = "high",
      width = 256,
      height = 256,
      frame_count = 1,
      axially_symmetrical = false,
      direction_count = 1,
	  scale = 0.45,
      shift = {0, -1.25},
    },
    signal_to_color_mapping =
    {
      {signal="signal-red", color={r=1,g=0,b=0}},
      {signal="signal-green", color={r=0,g=1,b=0}},
      {signal="signal-blue", color={r=0,g=0,b=1}},
      {signal="signal-yellow", color={r=1,g=1,b=0}},
      {signal="signal-pink", color={r=1,g=0,b=1}},
      {signal="signal-cyan", color={r=0,g=1,b=1}},
    },

    circuit_wire_connection_point =
    {
      shadow =
      {
        green = {0.6, -0.6},
		red = {0.6, -0.6},
      },
      wire =
      {
        green = {0.6,-2.25},
		red = {0.6,-2.25},
      }
    },
    circuit_connector_sprites = get_circuit_connector_sprites({0.30, -0.50}, {0.30, -0.50}, 18),
    circuit_wire_max_distance = 36.5

  },

  {
    type = "roboport",
    name = "backbone-logistics",
    icon = "__factory_backbone__/graphics/icon/backbone-icon.png",
    flags = {"placeable-neutral", "placeable-off-grid", "not-blueprintable"},
    minable = {hardness = 0.2, mining_time = 5},
    max_health = 350,
    corpse = "small-remnants",
    collision_box = {{0, 0}, {0, 0}},
    selection_box = {{-0.25, -0.25}, {0.25, 0.25}},
	logistics_radius = 18.5,
    construction_radius = 36.5,
	energy_source =
    {
      type = "electric",
      usage_priority = "secondary-input",
	  input_flow_limit = "5MW",
      buffer_capacity = "100MJ"
    },
	recharge_minimum = "5MJ",
    energy_usage = "50KW",
	charging_energy = "5MW",
	robot_slots_count = 0,
    material_slots_count = 0,
	charge_approach_distance = 5,
	charging_offsets =
    {
      {-1.5, -0.5}, {1.5, -0.5}, {1.5, 1.5}, {-1.5, 1.5},
    },
    vehicle_impact_sound =  { filename = "__base__/sound/car-metal-impact.ogg", volume = 1.0 },
    base =
    {
      filename = "__factory_backbone__/graphics/entity/blank.png",
      width = 1,
      height = 1,
--      shift = {1, -0.75}

    },
    base_animation =
    {
      filename = "__factory_backbone__/graphics/entity/blank.png",
      priority = "medium",
      width = 1,
      height = 1,
      frame_count = 1
    },
    base_patch =
    {
      filename = "__factory_backbone__/graphics/entity/blank.png",
      width = 1,
      height = 1,
      frame_count = 1
    },
    door_animation_up =
    {
      filename = "__factory_backbone__/graphics/entity/blank.png",
      width = 1,
      height = 1,
      frame_count = 1
    },
    door_animation_down =
    {
      filename = "__factory_backbone__/graphics/entity/blank.png",
      width = 1,
      height = 1,
      frame_count = 1
    },
    recharging_animation =
    {
       filename = "__factory_backbone__/graphics/entity/blank.png",
      width = 1,
      height = 1,
      frame_count = 1
    },
    recharging_light = {intensity = 0.4, size = 5},
    request_to_open_door_timeout = 15,
    spawn_and_station_height = 1.75,
    draw_logistic_radius_visualization = true,
    draw_construction_radius_visualization = true,
	circuit_wire_connection_point =
    {
      shadow =
      {
        red = {0.6, -0.6},
        green = {0.6, -0.6},
      },
      wire =
      {
        green = {0.6,-2.25},
		red = {0.6,-2.25},
      }
    },
    circuit_connector_sprites = get_circuit_connector_sprites({0.30, -0.50}, {0.30, -0.50}, 18),
    circuit_wire_max_distance = 36.5,
    default_available_logistic_output_signal = "signal-X",
    default_total_logistic_output_signal = "signal-Y",
    default_available_construction_output_signal = "signal-Z",
    default_total_construction_output_signal = "signal-T",

  }



}
)

